
<!DOCTYPE html>

<html class="no-js" lang="en">
<head>
<meta charset="utf-8"/>
<meta content="width=device-width,initial-scale=1" name="viewport"/>
<link href="../assets/images/favicon.png" rel="icon"/>
<meta content="mkdocs-1.2.3, mkdocs-material-7.3.6" name="generator"/>
<title>Installation de l'environnement - SecuWallet</title>
<link href="../assets/stylesheets/main.a57b2b03.min.css" rel="stylesheet"/>
<link href="../assets/stylesheets/palette.3f5d1f46.min.css" rel="stylesheet"/>
<meta content="#ab47bd" name="theme-color"/>
<link crossorigin="" href="https://fonts.gstatic.com" rel="preconnect"/>
<link href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700%7CRoboto+Mono&amp;display=fallback" rel="stylesheet"/>
<style>:root{--md-text-font-family:"Roboto";--md-code-font-family:"Roboto Mono"}</style>
<link href="https://unpkg.com/mermaid@8.5.1/dist/mermaid.css" rel="stylesheet"/>
<link href="../extra.css" rel="stylesheet"/>
</head>
<body data-md-color-accent="" data-md-color-primary="purple" data-md-color-scheme="slate" dir="ltr">
<script>function __prefix(e){return new URL("..",location).pathname+"."+e}function __get(e,t=localStorage){return JSON.parse(t.getItem(__prefix(e)))}</script>
<input autocomplete="off" class="md-toggle" data-md-toggle="drawer" id="__drawer" type="checkbox"/>
<input autocomplete="off" class="md-toggle" data-md-toggle="search" id="__search" type="checkbox"/>
<label class="md-overlay" for="__drawer"></label>
<div data-md-component="skip">
<a class="md-skip" href="#installation-de-lenvironnement">
          Skip to content
        </a>
</div>
<div data-md-component="announce">
</div>
<header class="md-header" data-md-component="header">
<nav aria-label="Header" class="md-header__inner md-grid">
<a aria-label="SecuWallet" class="md-header__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
<label class="md-header__button md-icon" for="__drawer">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2z"></path></svg>
</label>
<div class="md-header__title" data-md-component="header-title">
<div class="md-header__ellipsis">
<div class="md-header__topic">
<span class="md-ellipsis">
            SecuWallet
          </span>
</div>
<div class="md-header__topic" data-md-component="header-topic">
<span class="md-ellipsis">
            
              Installation de l'environnement
            
          </span>
</div>
</div>
</div>
<label class="md-header__button md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
</label>
<div class="md-search" data-md-component="search" role="dialog">
<label class="md-search__overlay" for="__search"></label>
<div class="md-search__inner" role="search">
<form class="md-search__form" name="search">
<input aria-label="Search" autocapitalize="off" autocomplete="off" autocorrect="off" class="md-search__input" data-md-component="search-query" name="query" placeholder="Search" required="" spellcheck="false" type="text"/>
<label class="md-search__icon md-icon" for="__search">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5z"></path></svg>
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</label>
<nav aria-label="Search" class="md-search__options">
<button aria-label="Clear" class="md-search__icon md-icon" tabindex="-1" type="reset">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z"></path></svg>
</button>
</nav>
</form>
<div class="md-search__output">
<div class="md-search__scrollwrap" data-md-scrollfix="">
<div class="md-search-result" data-md-component="search-result">
<div class="md-search-result__meta">
            Initializing search
          </div>
<ol class="md-search-result__list"></ol>
</div>
</div>
</div>
</div>
</div>
</nav>
</header>
<div class="md-container" data-md-component="container">
<main class="md-main" data-md-component="main">
<div class="md-main__inner md-grid">
<div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Navigation" class="md-nav md-nav--primary" data-md-level="0">
<label class="md-nav__title" for="__drawer">
<a aria-label="SecuWallet" class="md-nav__button md-logo" data-md-component="logo" href=".." title="SecuWallet">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54z"></path></svg>
</a>
    SecuWallet
  </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../0_Poster/">
        Poster
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../1_Resume/">
        Introduction
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../2_CahierDesCharges/">
        Cahier des charges
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../3_planning/">
        Planning
      </a>
</li>
<li class="md-nav__item md-nav__item--active md-nav__item--nested">
<input checked="" class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" id="__nav_5" type="checkbox"/>
<label class="md-nav__link" for="__nav_5">
          Documentation technique
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Documentation technique" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_5">
<span class="md-nav__icon md-icon"></span>
          Documentation technique
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../4_analyseExistant/">
        Analyse de L'existant
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../5_userStories/">
        User Stories
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../6_interface/">
        Interfaces
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../7_Architecture/">
        Architecture
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../8_outilsExterne/">
        Outils et librairies externes
      </a>
</li>
<li class="md-nav__item md-nav__item--active">
<input class="md-nav__toggle md-toggle" data-md-toggle="toc" id="__toc" type="checkbox"/>
<label class="md-nav__link md-nav__link--active" for="__toc">
          Installation de l'environnement
          <span class="md-nav__icon md-icon"></span>
</label>
<a class="md-nav__link md-nav__link--active" href="./">
        Installation de l'environnement
      </a>
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#apache2">
    Apache2
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#samba">
    Samba
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#mariadb">
    MariaDB
  </a>
<nav aria-label="MariaDB" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#installation">
    Installation
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#configuration">
    Configuration
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#hardhat">
    Hardhat
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../10_EncryptionBdd/">
        Encryption de base de données
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../docClasse/">
        Description Classes
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../Tests/">
        Tests
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../conclusion/">
        Conclusion
      </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item md-nav__item--nested">
<input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" id="__nav_6" type="checkbox"/>
<label class="md-nav__link" for="__nav_6">
          Annexes
          <span class="md-nav__icon md-icon"></span>
</label>
<nav aria-label="Annexes" class="md-nav" data-md-level="1">
<label class="md-nav__title" for="__nav_6">
<span class="md-nav__icon md-icon"></span>
          Annexes
        </label>
<ul class="md-nav__list" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="../JournalDeBord/">
        Journal de bord
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../tableDesIllustrations/">
        Table des illustrations
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../planningAnnexe/">
        Planning
      </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="../codeSource/">
        Code source
      </a>
</li>
</ul>
</nav>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc">
<div class="md-sidebar__scrollwrap">
<div class="md-sidebar__inner">
<nav aria-label="Table of contents" class="md-nav md-nav--secondary">
<label class="md-nav__title" for="__toc">
<span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
<ul class="md-nav__list" data-md-component="toc" data-md-scrollfix="">
<li class="md-nav__item">
<a class="md-nav__link" href="#apache2">
    Apache2
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#samba">
    Samba
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#mariadb">
    MariaDB
  </a>
<nav aria-label="MariaDB" class="md-nav">
<ul class="md-nav__list">
<li class="md-nav__item">
<a class="md-nav__link" href="#installation">
    Installation
  </a>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#configuration">
    Configuration
  </a>
</li>
</ul>
</nav>
</li>
<li class="md-nav__item">
<a class="md-nav__link" href="#hardhat">
    Hardhat
  </a>
</li>
</ul>
</nav>
</div>
</div>
</div>
<div class="md-content" data-md-component="content">
<article class="md-content__inner md-typeset">
<h1 id="installation-de-lenvironnement">Installation de l'environnement</h1>
<h2 id="apache2">Apache2</h2>
<p>Pour installer Apache2, il suffit d'entrer la commande suivante :
<div class="highlight"><pre><span></span><code>sudo apt install apache2 -y
</code></pre></div>
L'option -y permet de valider automatiquement tous les choix proposés par l'installation.</p>
<p>Pour vérifier l'installation d'Apache2, il faut utiliser cette commande :
<div class="highlight"><pre><span></span><code>sudo systemctl status apache2.service
</code></pre></div></p>
<figure id="fig83" style="width: 50%">
<img alt="Vérification de l'installation Apache2" src=".././img/verifApache2.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 83]:</span><b>Vérification de l'installation Apache2</b> </figcaption>
</figure>
<p>Afin de permettre d'exécuter des scripts PHP sur ce serveur il est nécessaire d'installer PHP ainsi que le module <a href="https://packages.debian.org/fr/sid/libapache2-mod-php">libapache2-mod-php</a> qui lie le PHP à apache2 avec cette commande :
<div class="highlight"><pre><span></span><code>sudo apt install php7.4 libapache2-mod-php7.4 php7.4-mbstring php7.4-mysql php7.4-curl php7.4-gd php7.4-zip -y
</code></pre></div></p>
<p>Le répertoire utilisé par défaut est /var/www/html. Après cette installation, pour vérifier que le serveur peut exécuter du PHP, il suffit de créer un fichier index.php qui contient :
<div class="highlight"><pre><span></span><code><span class="cp">&lt;?php</span> <span class="nb">phpinfo</span><span class="p">();</span> <span class="cp">?&gt;</span><span class="x"></span>
</code></pre></div></p>
<p>Une fois ce fichier créé, il suffit d'aller sur n'importe quel navigateur (dans mon cas Chromium) et de rentrer dans l'url 127.0.0.1/index.php si la page s'affiche comme l'image ci-dessous l'installation c'est bien déroulé.</p>
<figure id="fig84" style="width: 60%">
<img alt="Vérification de l'installation PHP" src=".././img/phpInfo.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 84]:</span><b>Vérification de l'installation PHP</b> </figcaption>
</figure>
<p>À partir de cette étape, le serveur HTTP est totalement fonctionnel. Néanmoins, pour des raisons de sécurité, il est important d'encrypter l'échange de donnée entre l'utilisateur et le serveur. Pour cela il faut le transformer en HTTPS ce qui forcera une connexion <a href="https://fr.wikipedia.org/wiki/Transport_Layer_Security">TLS</a>.</p>
<p>Pour faire cela, il faut premièrement créer une clé privée ainsi qu'un certificat. Dans mon cas, je vais utiliser OpenSSL pour générer ces éléments avec cette commande.
<div class="highlight"><pre><span></span><code>sudo openssl req -x509 -nodes -days <span class="m">365</span> -newkey rsa:2048 -keyout private.key -out certificate.crt
</code></pre></div></p>
<p>Il y a plusieurs informations demandées lors de la création d'un certificat comme l'image ci-dessous.</p>
<figure id="fig85" style="width: 50%">
<img alt="Création des certificats" src=".././img/CreationCertifica.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 85]:</span><b>Création des certificats</b> </figcaption>
</figure>
<p>L'information la plus importante est le paramètre "Common Name" il faut soit entrer le nom de domaine ou sinon directement l'adresse IP du serveur.</p>
<p>Ensuite, pour que ces fichiers soient utilisés par le serveur, il faut les déplacer dans le répertoire /etc/ssl/.../</p>
<div class="highlight"><pre><span></span><code>sudo mv private.key /etc/ssl/private/
sudo mv certificate.crt /etc/ssl/certs/
</code></pre></div>
<p>Les fichiers désormais dans les bons répertoires il faut éditer le fichier de configuration d'Apache2.
<div class="highlight"><pre><span></span><code>sudo nano /etc/apache2/sites-available/000-default.conf
</code></pre></div></p>
<p>Il y a déjà un bloc "VirtualHost" sur le port 80 (Port par défaut pour le HTTP), en dessous de celui-ci il faut rajouter ce nouveau bloc pointant sur le port 443 (Port par défaut pour le HTTPS).
<div class="highlight"><pre><span></span><code>&lt;VirtualHost *:443&gt;
        ServerAdmin webmaster@localhost
        DocumentRoot /var/www/html
        ErrorLog <span class="si">${</span><span class="nv">APACHE_LOG_DIR</span><span class="si">}</span>/error.log
        CustomLog <span class="si">${</span><span class="nv">APACHE_LOG_DIR</span><span class="si">}</span>/access.log combined
        SSLEngine on
        SSLProtocol all -SSLv2
        SSLCipherSuite HIGH:MEDIUM:!aNULL:!MD5
        SSLCertificateFile <span class="s2">"/etc/ssl/certs/certificate.crt"</span>
        SSLCertificateKeyFile <span class="s2">"/etc/ssl/private/private.key"</span>
&lt;/VirtualHost&gt;
</code></pre></div></p>
<p>Afin d'activer le ssl sur le serveur Apache2, il suffit d'utiliser cette commande :
<div class="highlight"><pre><span></span><code>sudo a2enmod ssl
</code></pre></div></p>
<p>Pour vérifier la syntaxe du fichier de configuration précédemment modifié, il faut utiliser cette commande :
<div class="highlight"><pre><span></span><code>sudo apache2ctl configtest
</code></pre></div></p>
<p>Exemple avec un fichier valide :</p>
<figure id="fig86" style="width: 50%">
<img alt="Vérification des certificats" src=".././img/VerificationCertificat.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 86]:</span><b>Vérification des certificats</b> </figcaption>
</figure>
<p>Afin de forcer la connexion en HTTPS sur le serveur, il faut ajouter dans le fichier de configuration d'Apache2 cette ligne à l'intérieur du bloc HTTP (Redirection sur le port 80) :
<div class="highlight"><pre><span></span><code>Redirect <span class="s2">"/"</span> <span class="s2">"https://IP_DU_SERVEUR/"</span>
</code></pre></div></p>
<h2 id="samba">Samba</h2>
<p>Afin d'avoir un accès simplifié au fichier du Raspberry j'ai installé "Samba" qui me permet de créer un disque réseau directement depuis ma machine.</p>
<p>Voici la commande d'installation.
<div class="highlight"><pre><span></span><code>sudo apt-get install samba samba-common-bin
</code></pre></div></p>
<p>Ensuite il faut éditer le fichier de configuration de "Samba".
<div class="highlight"><pre><span></span><code>sudo nano /etc/samba/smb.conf
</code></pre></div></p>
<p>Dans mon cas, j'ai décidé de partager tout à partir de la racine du Raspberry, mais il est également possible de partager uniquement un dossier. C'est pour cette raison que le champ "path" contient uniquement /. Le nom entre crochets va être utilisé pour créer le disque réseau.
<div class="highlight"><pre><span></span><code><span class="o">[</span>share<span class="o">]</span>
<span class="nv">path</span> <span class="o">=</span> /
<span class="nv">writeable</span><span class="o">=</span>Yes
create <span class="nv">mask</span><span class="o">=</span><span class="m">0777</span>
directory <span class="nv">mask</span><span class="o">=</span><span class="m">0777</span>
<span class="nv">public</span><span class="o">=</span>no
</code></pre></div>
Pour valider les modifications effectuées dans le fichier de configuration, il est nécessaire de redémarrer le service avec la commande suivante
<div class="highlight"><pre><span></span><code>sudo service smbd restart
</code></pre></div></p>
<p>Ensuite, il faut créer un utilisateur lié à "Samba" dans mon exemple ci-dessous où le nom de l'utilisateur est "thomapi".
<div class="highlight"><pre><span></span><code>sudo smbpasswd -a thomapi
</code></pre></div></p>
<p>Après cette étape la configuration de "Samba" est terminée. La suite se déroule sur Windows, il faut ouvrir l'explorateur de fichiers aller sur ce PC et cliquer sur "Connecter un lecteur réseau"</p>
<figure id="fig87" style="width: 60%">
<img alt="Explorateur de fichiers Windows 10" src=".././img/sambaExplorateurFichiers.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 87]:</span><b>Explorateur de fichiers Windows 10</b> </figcaption>
</figure>
<p>La fenêtre ci-dessous va s'ouvrir, il faut :</p>
<ol>
<li>Ce premier champ sert à préciser la lettre sous laquelle le lecteur va s'appeler.</li>
<li>Ce champ doit contenir l'IP du Raspberry suivi du nom qui a été spécifié dans le fichier de configuration.</li>
<li>Après avoir spécifié les 2 champs précédents, il suffit de cliquer sur "Terminer".</li>
</ol>
<figure id="fig88" style="width: 30%">
<img alt="Ajout disque réseau" src=".././img/AjoutDisqueReseau1.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 88]:</span><b>Ajout disque réseau</b> </figcaption>
</figure>
<p>La dernière étape est d'entrer les noms d'utilisateur ainsi que son mot de passe précédemment paramétré.</p>
<figure id="fig89" style="width: 30%">
<img alt="Connexion à l'utilisateur Samba" src=".././img/AjoutDisqueReseau2.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 89]:</span><b>Connexion à l'utilisateur Samba</b> </figcaption>
</figure>
<p>Voici ci-dessous les fichiers du Raspberry disponible sous forme de disque réseau sur une machine Windows.</p>
<figure id="fig90" style="width: 40%">
<img alt="Disque réseau connecté au Raspberry" src=".././img/AjoutDisqueReseau3.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 90]:</span><b>Disque réseau connecté au Raspberry</b> </figcaption>
</figure>
<h2 id="mariadb">MariaDB</h2>
<h3 id="installation">Installation</h3>
<div class="highlight"><pre><span></span><code>sudo apt install mariadb-server
</code></pre></div>
<h3 id="configuration">Configuration</h3>
<p>Afin de configurer, il est nécessaire d'exécuter le script Shell en utilisant la commande suivante.</p>
<div class="highlight"><pre><span></span><code>sudo mysql_secure_installation
</code></pre></div>
<p>Suite à cette dernière, plusieurs entrées d’utilisateur sont demandées. Il faut accepter toutes les questions.</p>
<figure id="fig91" style="width: 40%">
<img alt="Configuration de MariaDB" src=".././img/MysqlSecureInstallation.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 91]:</span><b>Configuration de MariaDB</b> </figcaption>
</figure>
<p>Suite a cela, le mot de passe de l'utilisateur root a été modifié et de supprimé les utilisateurs anonymes ainsi que la base de données de tests créés à l'installation du serveur MariaDB.</p>
<p>Pour créer la base de données nécessaire à mon projet, j'utilise les commandes <a href="https://fr.wikipedia.org/wiki/Structured_Query_Language">SQL</a> suivantes :</p>
<div class="highlight"><pre><span></span><code><span class="k">CREATE</span><span class="w"> </span><span class="k">DATABASE</span><span class="w"> </span><span class="n">NomBaseDedonnées</span><span class="p">;</span><span class="w"></span>
</code></pre></div>
<p>Pour créer l'utilisateur local qui se connectera à ma base de données en lui donnant uniquement les droits sur la base de données précédemment créée.</p>
<div class="highlight"><pre><span></span><code><span class="k">GRANT</span><span class="w"> </span><span class="k">ALL</span><span class="w"> </span><span class="k">ON</span><span class="w"> </span><span class="o">*</span><span class="n">NonBaseDeDonnées</span><span class="o">*</span><span class="w"> </span><span class="k">TO</span><span class="w"> </span><span class="s1">'NomUtilisateur'</span><span class="o">@</span><span class="s1">'localhost'</span><span class="w"> </span><span class="n">IDENTIFIED</span><span class="w"> </span><span class="k">BY</span><span class="w"> </span><span class="s1">'MotDePasse'</span><span class="w"> </span><span class="k">WITH</span><span class="w"> </span><span class="k">GRANT</span><span class="w"> </span><span class="k">OPTION</span><span class="p">;</span><span class="w"></span>
</code></pre></div>
<p>Cette commande permet de sélectionner la base de données pour que la commande suivante s'exécute sans erreur.</p>
<div class="highlight"><pre><span></span><code><span class="n">USE</span><span class="w"> </span><span class="n">NomBaseDedonnées</span><span class="w"></span>
</code></pre></div>
<p>Pour créer la table "Users" qui contient l'email, le mot de passe et une clé nécessaire à <a href="https://fr.wikipedia.org/wiki/Google_Authenticator">Google Authenticator</a> j'ai dû entrer cette commande :</p>
<div class="highlight"><pre><span></span><code><span class="k">CREATE</span><span class="w"> </span><span class="k">TABLE</span><span class="w"> </span><span class="o">`</span><span class="n">Users</span><span class="o">`</span><span class="w"> </span><span class="p">(</span><span class="w"></span>
<span class="w">  </span><span class="o">`</span><span class="n">idUsers</span><span class="o">`</span><span class="w"> </span><span class="nb">int</span><span class="p">(</span><span class="mi">11</span><span class="p">)</span><span class="w"> </span><span class="k">NOT</span><span class="w"> </span><span class="k">NULL</span><span class="w"> </span><span class="n">AUTO_INCREMENT</span><span class="p">,</span><span class="w"></span>
<span class="w">  </span><span class="o">`</span><span class="n">mail</span><span class="o">`</span><span class="w"> </span><span class="nb">varchar</span><span class="p">(</span><span class="mi">100</span><span class="p">)</span><span class="w"> </span><span class="k">NOT</span><span class="w"> </span><span class="k">NULL</span><span class="p">,</span><span class="w"></span>
<span class="w">  </span><span class="o">`</span><span class="n">password</span><span class="o">`</span><span class="w"> </span><span class="nb">varchar</span><span class="p">(</span><span class="mi">40</span><span class="p">)</span><span class="w"> </span><span class="k">NOT</span><span class="w"> </span><span class="k">NULL</span><span class="p">,</span><span class="w"></span>
<span class="w">  </span><span class="o">`</span><span class="n">secretKey</span><span class="o">`</span><span class="w"> </span><span class="nb">varchar</span><span class="p">(</span><span class="mi">16</span><span class="p">)</span><span class="w"> </span><span class="k">NOT</span><span class="w"> </span><span class="k">NULL</span><span class="p">,</span><span class="w"></span>
<span class="w">  </span><span class="k">PRIMARY</span><span class="w"> </span><span class="k">KEY</span><span class="w"> </span><span class="p">(</span><span class="o">`</span><span class="n">idUsers</span><span class="o">`</span><span class="p">)</span><span class="w"></span>
<span class="p">)</span><span class="w"> </span><span class="n">ENGINE</span><span class="o">=</span><span class="n">InnoDB</span><span class="w"> </span><span class="k">DEFAULT</span><span class="w"> </span><span class="n">CHARSET</span><span class="o">=</span><span class="n">utf8mb4</span><span class="p">;</span><span class="w"></span>
</code></pre></div>
<h2 id="hardhat">Hardhat</h2>
<p>Comme la plupart des librairies Ethereum, Hardhat est écrit en Javasacript. Afin de pouvoir exécuter ce code en dehors d'un navigateur internet, il est nécessaire d'installer Node.Js à l'aide des 3 commandes suivantes.</p>
<div class="highlight"><pre><span></span><code>sudo apt install curl git
curl -sL https://deb.nodesource.com/setup_16.x <span class="p">|</span> sudo -E bash -
sudo apt install nodejs
</code></pre></div>
<p>Une fois cela terminé, pour installer Hardhat il faut utiliser la commande npm (Node.js package manager). Npm est un manager de paquets et un dépôt en ligne pour des scripts écrits en JavaScript.</p>
<p>Premièrement il faut créer un répertoire qui va contenir le serveur Hardhat. Une fois créer il faut se rendre dans celui-ci à l'aide de la commande cd.  </p>
<div class="highlight"><pre><span></span><code>mkdir hardhat
<span class="nb">cd</span> hardhat
</code></pre></div>
<p>Pour installer le paquet Hardhat ainsi que ces dépendances, il faut exécuter les commandes suivantes.</p>
<div class="highlight"><pre><span></span><code>npm init --yes
npm install --save-dev hardhat
</code></pre></div>
<p>Pour créer le projet Hardhat, il faut entrer la commande suivante dans le même répertoire créer précédemment. </p>
<p><div class="highlight"><pre><span></span><code>npx hardhat
</code></pre></div>
Grâce aux flèches du clavier et en appuyant sur la touche "Entrer", il faut sélectionner "Create an empty harhadt.config.js".</p>
<figure id="fig92" style="width: 40%">
<img alt="Création du projet Hardhat" src=".././img/InstallHardhat.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 92]:</span><b>Création du projet Hardhat</b> </figcaption>
</figure>
<p>Suite à cela, le serveur Hardhat est fonctionnel. Pour lancer le serveur HTTP et le Websocket JSON-RPC, qui nous permettront de communiquer avec la blockchain, il faut exécuter la commande suivante.</p>
<div class="highlight"><pre><span></span><code>npx hardhat node
</code></pre></div>
<p>Lors du lancement de Hardhat le serveur se créer avec 20 portefeuilles disposant chacun de 10'000 Ethereum permettant de tester les différentes actions possible sur la blockchain.</p>
<figure id="fig93" style="width: 40%">
<img alt="Compte généré Hardhat" src=".././img/HardhatCompteGenerer.png" width="100%"/>
<figcaption>
<span class="fig">[Fig 93]:</span><b>Compte généré Hardhat</b> </figcaption>
</figure>
</article>
</div>
</div>
</main>
<footer class="md-footer">
<nav aria-label="Footer" class="md-footer__inner md-grid">
<a aria-label="Previous: Outils et librairies externes" class="md-footer__link md-footer__link--prev" href="../8_outilsExterne/" rel="prev">
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12z"></path></svg>
</div>
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Previous
              </span>
              Outils et librairies externes
            </div>
</div>
</a>
<a aria-label="Next: Encryption de base de données" class="md-footer__link md-footer__link--next" href="../10_EncryptionBdd/" rel="next">
<div class="md-footer__title">
<div class="md-ellipsis">
<span class="md-footer__direction">
                Next
              </span>
              Encryption de base de données
            </div>
</div>
<div class="md-footer__button md-icon">
<svg viewbox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><path d="M4 11v2h12l-5.5 5.5 1.42 1.42L19.84 12l-7.92-7.92L10.5 5.5 16 11H4z"></path></svg>
</div>
</a>
</nav>
<div class="md-footer-meta md-typeset">
<div class="md-footer-meta__inner md-grid">
<div class="md-footer-copyright">
        
        
          Made with
          <a href="https://squidfunk.github.io/mkdocs-material/" rel="noopener" target="_blank">
            Material for MkDocs
          </a>
 ... <a class="link--pdf-download" download href="../pdf/document.pdf" title="PDF">download PDF</a></div>
</div>
</div>
</footer>
</div>
<div class="md-dialog" data-md-component="dialog">
<div class="md-dialog__inner md-typeset"></div>
</div>
<script id="__config" type="application/json">{"base": "..", "features": [], "translations": {"clipboard.copy": "Copy to clipboard", "clipboard.copied": "Copied to clipboard", "search.config.lang": "en", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "Search", "search.result.placeholder": "Type to start searching", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.term.missing": "Missing", "select.version.title": "Select version"}, "search": "../assets/javascripts/workers/search.fcfe8b6d.min.js", "version": null}</script>
<script src="../assets/javascripts/bundle.b1047164.min.js"></script>
<script src="https://unpkg.com/mermaid@8.5.1/dist/mermaid.min.js"></script>
</body>
</html>